#ifndef _BBCBILLBOARDCLOUD_H
#define _BBCBILLBOARDCLOUD_H

#include <BBCBillboardGroup.h>
#include <BBCBillboard.h>
#include <BBCEntityCluster.h>
#include <BBCEntity.h>

namespace BBC {

class _BBCExport BillboardCloud {
  public:
    BillboardCloud();

    virtual ~BillboardCloud();


  protected:
	  std::vector<BillboardPtr> mBillboardList;
	  
	  std::vector<BillboardGroupPtr> mBillboardGroupList;

  public:
	std::vector<BillboardPtr>* getBillboardList();

	void setBillboardList(std::vector<BillboardPtr> &value);

	void clearBillboardCloud();

    void addBillboard(BillboardPtr value);

    void removeBillboard(unsigned int value);

	BillboardPtr getBillboard(unsigned int value);	

	unsigned int BillboardCloud::getNumBillboards();

	void generateBillboardCloud(bool mergeBillboards);

	void initializeBillboardCloudGroups(unsigned int numberGroups);

	void generateBillboardCloudGroups();

	unsigned int getNumBillboardGroups();

	BillboardGroupPtr getBillboardGroup(unsigned int iBillboardGroup);

	void addBillboardGroup(BillboardGroupPtr value); 

	void removeBillboardGroup(unsigned int value);

	EntityPtr getEntity();

	EntityPtr getEntityGrouped();

	void setEntity(EntityPtr value);

	void setEntityGrouped(EntityPtr value);

  protected:
	EntityPtr mEntity;
	
	EntityPtr mEntityGrouped;
};

}
#endif
